#define __USE_FIXED_PROTOTYPES__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "othello.h"


static int judge(char *board);	/* presented by abura. */


int human(char *board, int status)
{
	int i;
	int x, y;
	int c;
	char buf[100];

	if(passp(status) || initp(status))
		return 0;
	
	for (i=0; i<64; i++) {
		if (Put(board, i, MY_COLOR, NOT_CHANGE) > 0) break;
	}
	if (i == 64) {
		/* NOTREACHED */
		abort();
	}
	
	c = 64;
	for (i=0; i<64; i++) {
		if (board[i] == MY_COLOR || board[i] == OP_COLOR) c--;
	}
	
	/*printf("X=\n");*/
	printf("X=¡áġšơǡ\n");
	while (1) {
		printf("human> %dꡣɤ֤ޤ? ", c);
		if (fgets(buf, sizeof(buf), stdin)) {
			if (!strncmp(buf, "judge", 5)) {
				printf("ǽȽԤޤ...\n");
				i = judge(board);
				if (i>0) {
					printf("Ƚ: %dܺǤʤξǤ\n", i);
				}else if (i<0) {
					printf("Ƚ: %dܺǤʤ餱Ǥ\n", -i);
				}else {
					printf("Ƚ: ʬǤ\n");
				}
				continue;
			}
			if (strlen(buf)==3 && isalpha(buf[0]) && isdigit(buf[1]) &&
			  tolower(buf[0])>='a' && tolower(buf[0])<='h' &&
			  buf[1]>='1' && buf[1]<='8') {
				y = buf[1] - '0';
				x = tolower(buf[0]) - 'a' + 1;
				if (Put(board, (y-1)*8 + (x-1), MY_COLOR, NOT_CHANGE)) {
					break;
				}
				printf("human> ɸ(%d,%d)ˤ֤ޤá\n", x, y);
				continue;
			}else if (
			  sscanf(buf, "%d%d", &x, &y) == 2 &&
			  x>0 && x<9 &&
			  y>0 && y<9) {
				if (Put(board, (y-1)*8 + (x-1), MY_COLOR, NOT_CHANGE)) {
					break;
				}
				printf("human> ɸ(%d,%d)ˤ֤ޤá\n", x, y);
				continue;
			}
		}
		if (feof(stdin)) {
			printf("human> λޤ...\n");
			exit(1);
		}
		printf(
		" ϥ顼 xɸ(18) yɸ(18) \n"
		" : 3 2[ret]\n"
		"     judge[ret]\n"
		);
	}
	printf("human> ɸ(%d,%d)֤ޤ\n", x, y);
	return (y-1)*8 + (x-1);
}

/*** tree search ************************************************************/

/*
 * ǽȽ롼
 */

typedef struct abura_board_s {
  char x[91];
} abura_board;

static void abura_init(abura_board *ab, char *board)
{
  int i, j;

  for (i = 0; i < 8; i++) {
    for (j = 0; j < 8; j++) {
      ab->x[10 + i * 9 + j] = board[i * 8 + j];
    }
    ab->x[18 + i * 9] = -1;
  }
  for (i = 0; i < 10; i++) ab->x[i] = ab->x[i + 81] = -1;
}

static int abura_put(abura_board *ab, int place, int color)
{
  static int d[] = {-10, -9, -8, -1, 1, 8, 9, 10};
  int i, c = 0, tc;

  if (ab->x[place]) return 0;
  tc = color == MY_COLOR ? OP_COLOR : MY_COLOR;
  for (i = 0; i < 8; i++) {
    int p = place + d[i]; /* " + d[i]" for speed */
    if (ab->x[p] == tc) {    /* for speed */
      do {p += d[i];} while (ab->x[p] == tc);
      if (ab->x[p] == color) {
        while ((p -= d[i]) != place) ab->x[p] = color, c++;
      }
    }
  }
  if (c) ab->x[place] = color;
  return c;
}

typedef struct abura_work_s {
  abura_board ab;
  int         rest;
  int         adv;    /* ʬ -  */
  int         qualify;
  int         prev_qualify;
} abura_work;

static int abura_seme(abura_work *);
static int abura_uke(abura_work *);

static int abura_seme(abura_work *argp)
{
  abura_work next;
  int        i, f;

  next.ab           = argp->ab;
  next.rest         = argp->rest - 1;
  next.qualify      = 65;
  next.prev_qualify = argp->qualify;

  for (i = 10; i < 81; i++) {
    int c, pt;
    if ((c = abura_put(&next.ab, i, MY_COLOR)) > 0) {
      next.adv = argp->adv + 1 + c + c;
      pt = argp->rest == 1 ? next.adv : abura_uke(&next);
      if (pt <= argp->qualify) return argp->qualify; /* -´ */
      next.ab = argp->ab;
      if (pt < next.qualify) next.qualify = pt;
    }
  }
  if (next.qualify < 65) return next.qualify;
  next.qualify      = argp->qualify;
  next.prev_qualify = argp->prev_qualify;
  f = 0;
  for (i = 10; i < 81; i++) {
    int c, pt;

    if ((c = abura_put(&next.ab, i, OP_COLOR)) > 0) {
      next.adv = argp->adv - 1 - c - c;
      pt = argp->rest == 1 ? next.adv : abura_seme(&next);
      if (pt >= argp->prev_qualify) return argp->prev_qualify;
      f = 1;
      next.ab = argp->ab;
      if (pt > next.qualify) next.qualify = pt;
    }
  }
  return f ? next.qualify : argp->adv;
}

static int abura_uke(abura_work *argp)
{
  abura_work next;
  int        i, f;

  next.ab      = argp->ab;
  next.rest    = argp->rest - 1;
  next.qualify      = -65;
  next.prev_qualify = argp->qualify;

  for (i = 10; i < 81; i++) {
    int c, pt;

    if ((c = abura_put(&next.ab, i, OP_COLOR)) > 0) {
      next.adv = argp->adv - 1 - c - c;
      pt = argp->rest == 1 ? next.adv : abura_seme(&next);
      if (pt >= argp->qualify) return argp->qualify; /* -´ */
      next.ab = argp->ab;
      if (pt > next.qualify) next.qualify = pt;
    }
  }
  if (next.qualify > -65) return next.qualify;

  next.qualify      = argp->qualify;
  next.prev_qualify = argp->prev_qualify;
  f = 0;
  for (i = 10; i < 81; i++) {
    int c, pt;

    if ((c = abura_put(&next.ab, i, MY_COLOR)) > 0) {
      next.adv = argp->adv + 1 + c + c;
      pt = argp->rest == 1 ? next.adv : abura_uke(&next);
      if (pt <= argp->prev_qualify) return argp->prev_qualify;
      f = 1;
      next.ab = argp->ab;
      if (pt < next.qualify) next.qualify = pt;
    }
  }
  return f ? next.qualify : argp->adv;
}

static int judge(char *board)	/* presented by abura. */
{
  abura_work arg, next;
  int        my, op, i;

  CountDisks(board, &my, &op);
  abura_init(&arg.ab, board);

  arg.adv      = my - op;
  next.ab      = arg.ab;
  next.rest    = 63 - my - op;
  next.qualify = 65;
  for (i = 10; i < 81; i++) {
    int c, pt;

    if ((c = abura_put(&next.ab, i, MY_COLOR)) > 0) {
      next.adv = arg.adv + 1 + c + c;
      pt = arg.rest == 1 ? next.adv : abura_uke(&next);
      next.ab = arg.ab;
      if (pt < next.qualify) next.qualify = pt;
    }
  }
  return next.qualify;
}
